%define with_xine 1

%define gstreamer_version	0.10.14
%define gstreamer_plugins_base_version	0.10.14
%define gstreamer_plugins_good_version	0.10.6

Distribution:		CCux
Packager:		Christian Metzen <metzench@ccux-linux.de>

Summary: 		Movie player for GNOME
Name: 			totem
Version: 		2.23.0
Release: 		2
License: 		GPL
Group: 			Multimedia/Video
URL: 			http://www.hadess.net/totem.php3
Source0: 		http://ftp.gnome.org/pub/GNOME/sources/totem/0.99/totem-%{version}.tar.bz2
Source1: 		totem-bin-backend-ondemand.sh
Patch0: 		totem-xul-4.patch
BuildRoot: 		%{_tmppath}/%{name}-%{version}-%{release}-root

Requires(pre): GConf
Requires(preun): GConf
Requires(post): GConf
Requires(post): desktop-file-utils
Requires(post): scrollkeeper
Requires(postun): desktop-file-utils
Requires(postun): scrollkeeper

Requires: 		gnome-desktop
Requires: 		gstreamer10 >= %gstreamer_version
Requires: 		gst-plugins-base >= %gstreamer_plugins_base_version
Requires: 		gst-plugins-good >= %gstreamer_plugins_good_version
Requires: 		iso-codes

BuildRequires: 		pkg-config gettext scrollkeeper
BuildRequires: 		gstreamer10-devel >= %gstreamer_version
BuildRequires: 		gst-plugins-base-devel >= %gstreamer_plugins_base_version
BuildRequires: 		gnome-desktop-devel gnome-vfs-devel, libglade-devel
BuildRequires: 		perl-XML-Parser
BuildRequires: 		iso-codes-devel
BuildRequires: 		firefox-devel
BuildRequires: 		gnome-icon-theme
BuildRequires: 		nautilus-devel
BuildRequires: 		libXtst-devel
BuildRequires: 		libXxf86vm-devel
BuildRequires: 		libXt-devel
BuildRequires: 		dbus-devel
BuildRequires: 		hal-devel
BuildRequires: 		gnome-doc-utils control-center-devel 
BuildRequires: 		libgalago-devel
BuildRequires: 		gmyth-devel
BuildRequires: 		python-devel gnome-python-devel PyGTK-devel
BuildRequires: 		tracker-devel
BuildRequires: 		libepc-devel
BuildRequires: 		totem-pl-parser-devel

%description
Totem is simple movie player for the Gnome desktop. It features a
simple playlist, a full-screen mode, seek and volume controls, as well as
a pretty complete keyboard navigation.

%package	gstreamer
Summary: 	Gstreamer backend for Totem
Group: 		Multimedia
Provides: 	%{name}-backend
Provides: 	%{name}-gstreamer
Obsoletes: 	%{name}-gstreamer < 2.23.0
Requires: 	%{name} = %{version}
Requires: 	gstreamer10 >= %gstreamer_version
Requires: 	gst-plugins-base >= %gstreamer_plugins_base_version
Requires: 	gst-plugins-good >= %gstreamer_plugins_good_version
BuildRequires: 	gstreamer10-devel >= %gstreamer_version
BuildRequires: 	gst-plugins-base-devel >= %gstreamer_plugins_base_version
BuildRequires: 	gst-plugins-good >= %gstreamer_plugins_good_version

%description	gstreamer
This package provides the gstreamer backend for the Totem media player.

%if %{with_xine}
%package	xine
Summary: 	Xine backend for Totem
Group: 		Multimedia
Provides: 	%{name}-backend
Provides: 	%{name}-xine
Obsoletes: 	%{name}-xine < 2.23.0
Requires: 	%{name} = %{version}
Requires: 	xine-lib
BuildRequires: 	xine-lib-devel

%description	xine
This package provides the xine backend for the Totem media player.
%endif

%package	mozplugin
Summary: 	Mozilla plugin for Totem
Group: 		Internet/Plugins
Requires: 	firefox

%description	mozplugin
Totem is simple movie player for the Gnome desktop. The mozilla plugin
for totem allows totem to be embeded into a web browser. 

#%package lirc
#Summary: LIRC (Infrared remote) plugin for Totem
#Group: Applications/Multimedia
#Requires: %{name} = %{version}-%{release}
#
#%description lirc
#A plugin to add LIRC (Infrared remote) support to Totem.

%package	galago
Summary: 	Galago (Instant Messenger status) plugin for Totem
Group: 		Multimedia
Requires: 	%{name} = %{version}-%{release}

%description	galago
A plugin to allow Totem to set Instant Messenger statuses when
playing a movie in fullscreen.

Your Instant Messenging program might require a plugin to take
advantage of this feature.

%package	mythtv
Summary: 	MythTV plugin for Totem
Group: 		Multimedia
Requires: 	%{name} = %{version}-%{release}

%description	mythtv
A plugin to allow access to recordings on a remote MythTV server.

%package	youtube
Summary: 	YouTube plugin for Totem
Group: 		Multimedia
Requires: 	python-gdata
Requires: 	%{name} = %{version}-%{release}

%description	youtube
A plugin to allow browsing YouTube videos, and watching them.

To play back the videos however, you will need codecs that are not
available in the Fedora repositories.

%package	tracker
Summary: 	Tracker-based video search plugin for Totem
Group: 		Multimedia
Requires: 	%{name} = %{version}-%{release}

%description	tracker
A plugin to allow searching local videos, based on their tags, metadata,
or filenames, as indexing by the Tracker indexer.

%package	publish
Summary: 	Share your playlist with other Totems on the local network
Group: 		Multimedia
Requires: 	%{name} = %{version}-%{release}

%description	publish
A plugin to allow you to share your current playlist (and the files included
in that playlist) with other Totems on the same local network.

%package	nautilus
Summary: 	Video and Audio Properties tab for Nautilus
Group: 		Multimedia
Requires: 	%{name} = %{version}-%{release}
Provides: 	totem-nautilus-xine
Provides: 	totem-nautilus-gstreamer
Obsoletes: 	totem-nautilus-xine < 2.23.0
Obsoletes: 	totem-nautilus-gstreamer < 2.23.0

%description	nautilus
A Nautilus extension that shows the properties of audio and video files in•
the properties dialogue.

%prep
%setup -q -c
# Whatever needs to be changed in both copies do here
## remember to update me when changing %doc
for i in AUTHORS COPYING NEWS README TODO;do
  cp totem-%{version}/$i .
done

pushd totem-%{version}
#%patch0 -p0 -b .xulrunner

# regen
#aclocal
#automake
#autoconf
popd

# duplicate sources
cp -a totem-%{version} xine
mv totem-%{version} gstreamer

%build

pushd gstreamer
# try to work around a problem where gst-inspect does 
# not find playbin the first time around
DBUS_FATAL_WARNINGS=0 /usr/bin/gst-inspect-0.10 --print-all > /dev/null
export MOZILLA_PLUGINDIR=%{_libdir}/mozilla/plugins
%configure --sysconfdir=%_sysconfdir/gnome --localstatedir=/var/lib --libexecdir=$(pkg-config --variable=prefix ORBit-2.0)/lib/totem \
  --enable-gstreamer \
  --enable-mozilla \
  --enable-nautilus \
  --disable-scrollkeeper \
  --disable-nvtv

make %{?_smp_mflags}
popd

%if %{with_xine}
# Build the xine-lib backend with minimum dependencies
pushd xine
export MOZILLA_PLUGINDIR=%{_libdir}/mozilla/plugins
%configure --sysconfdir=%_sysconfdir/gnome --localstatedir=/var/lib --libexecdir=$(pkg-config --variable=prefix ORBit-2.0)/lib/totem \
  --enable-xine \
  --disable-gstreamer \
  --disable-mozilla   \
  --disable-nautilus  \
  --disable-scrollkeeper  \
  --disable-nvtv

cd src/backend/
make %{?_smp_mflags}
popd
%endif

%install
rm -rf $RPM_BUILD_ROOT
export GCONF_DISABLE_MAKEFILE_SCHEMA_INSTALL=1

# GSTREAMER INSTALL
pushd gstreamer/
make install DESTDIR=$RPM_BUILD_ROOT
# move the backend library away
mv $RPM_BUILD_ROOT/%{_libdir}/libbaconvideowidget.so.0.0.0 $RPM_BUILD_ROOT/%{_libdir}/libbaconvideowidget-gstreamer.so.0.0.0
# language hack
%find_lang %{name} --with-gnome
mv %{name}.lang ../
popd

%if %{with_xine}
# XINE INSTALL
pushd xine/src/backend
make install DESTDIR=$RPM_BUILD_ROOT
mv $RPM_BUILD_ROOT/%{_libdir}/libbaconvideowidget.so.0.0.0 $RPM_BUILD_ROOT/%{_libdir}/libbaconvideowidget-xine.so.0.0.0
popd
%endif

# Restore the default backend
ln -sf %{_libdir}/libbaconvideowidget-gstreamer.so.0.0.0 $RPM_BUILD_ROOT/%{_libdir}/libbaconvideowidget.so.0.0.0

rm -f $RPM_BUILD_ROOT%{_libdir}/totem/plugins/*/*.{a,la} \
 $RPM_BUILD_ROOT%{_libdir}/mozilla/plugins/*.{a,la} \
 $RPM_BUILD_ROOT%{_libdir}/nautilus/extensions-2.0/*.{a,la} \
 $RPM_BUILD_ROOT%{_libdir}/libbaconvideowidget*.{a,la}

%find_lang %{name} --with-gnome

install -m755 %{SOURCE1} $RPM_BUILD_ROOT%{_bindir}/%{name}-backend

%clean
rm -rf $RPM_BUILD_ROOT

%post
scrollkeeper-update -q
update-desktop-database -q
export GCONF_CONFIG_SOURCE=`gconftool-2 --get-default-source`
gconftool-2 --makefile-install-rule \
        %{_sysconfdir}/gnome/gconf/schemas/totem.schemas \
        %{_sysconfdir}/gnome/gconf/schemas/totem-handlers.schemas \
        %{_sysconfdir}/gnome/gconf/schemas/totem-video-thumbnail.schemas \
 >& /dev/null || :
touch %{_datadir}/icons/hicolor
if [ -x /usr/bin/gtk-update-icon-cache ]; then
  /usr/bin/gtk-update-icon-cache --quiet %{_datadir}/icons/hicolor
fi

%post gstreamer -p /sbin/ldconfig

%post xine -p /sbin/ldconfig

%pre
if [ "$1" -gt 1 ]; then
    export GCONF_CONFIG_SOURCE=`gconftool-2 --get-default-source`
    gconftool-2 --makefile-uninstall-rule \
        %{_sysconfdir}/gnome/gconf/schemas/totem.schemas \
        %{_sysconfdir}/gnome/gconf/schemas/totem-handlers.schemas \
        %{_sysconfdir}/gnome/gconf/schemas/totem-video-thumbnail.schemas \
 >& /dev/null || :
fi

%preun
if [ "$1" -eq 0 ]; then
    export GCONF_CONFIG_SOURCE=`gconftool-2 --get-default-source`
    gconftool-2 --makefile-uninstall-rule \
        %{_sysconfdir}/gnome/gconf/schemas/totem.schemas \
        %{_sysconfdir}/gnome/gconf/schemas/totem-handlers.schemas \
        %{_sysconfdir}/gnome/gconf/schemas/totem-video-thumbnail.schemas \
 >& /dev/null || :
fi

%postun
/sbin/ldconfig
scrollkeeper-update -q
update-desktop-database -q
touch %{_datadir}/icons/hicolor
if [ -x /usr/bin/gtk-update-icon-cache ]; then
  /usr/bin/gtk-update-icon-cache --quiet %{_datadir}/icons/hicolor
fi

%postun gstreamer -p /sbin/ldconfig

%postun xine -p /sbin/ldconfig

%post mythtv
export GCONF_CONFIG_SOURCE=`gconftool-2 --get-default-source`
gconftool-2 --makefile-install-rule \
        %{_sysconfdir}/gnome/gconf/schemas/totem-mythtv.schemas \
 >& /dev/null || :

%pre mythtv
if [ "$1" -gt 1 ]; then
    export GCONF_CONFIG_SOURCE=`gconftool-2 --get-default-source`
    if [ -f %{_sysconfdir}/gnome/gconf/schemas/totem-mythtv.schemas ] ; then
        gconftool-2 --makefile-uninstall-rule \
            %{_sysconfdir}/gnome/gconf/schemas/totem-mythtv.schemas \
            >& /dev/null || :
    fi
fi

%preun mythtv
if [ "$1" -eq 0 ]; then
    export GCONF_CONFIG_SOURCE=`gconftool-2 --get-default-source`
    if [ -f %{_sysconfdir}/gnome/gconf/schemas/totem-mythtv.schemas ] ; then
        gconftool-2 --makefile-uninstall-rule \
            %{_sysconfdir}/gnome/gconf/schemas/totem-mythtv.schemas \
            >& /dev/null || :
    fi
fi

%files -f %{name}.lang
%defattr(-,root,root,-)
%doc AUTHORS COPYING NEWS README TODO
%config %{_sysconfdir}/gnome/gconf/schemas/totem.schemas
%config %{_sysconfdir}/gnome/gconf/schemas/totem-handlers.schemas
%config %{_sysconfdir}/gnome/gconf/schemas/totem-video-thumbnail.schemas
%{_bindir}/%{name}
%{_bindir}/%{name}-backend
%{_bindir}/%{name}-video-thumbnailer
%{_bindir}/%{name}-video-indexer
%{_bindir}/%{name}-audio-preview
%{_datadir}/applications/%{name}.desktop
%{_datadir}/%{name}/
%dir %{_libdir}/totem/totem
%{_libdir}/totem/totem/totem-bugreport.py*
%{_libdir}/libbaconvideowidget.so*
%dir %{_libdir}/totem/plugins
%{_libdir}/totem/plugins/gromit
%{_libdir}/totem/plugins/ontop
%{_libdir}/totem/plugins/screensaver
%{_libdir}/totem/plugins/skipto
%{_libdir}/totem/plugins/properties
%{_libdir}/totem/plugins/media-player-keys
%{_libdir}/totem/plugins/totem
%{_libdir}/totem/plugins/thumbnail
#%{_libdir}/totem/plugins/bemused

%{_datadir}/icons/hicolor/*/apps/totem.png
%{_datadir}/icons/hicolor/scalable/apps/totem.svg
%{_mandir}/man1/%{name}.1*
%{_mandir}/man1/totem-video-thumbnailer.1.gz

%files nautilus
%defattr(-, root, root)
%{_libdir}/nautilus/extensions-2.0/*.so*

%files galago
%defattr(-, root, root)
%{_libdir}/totem/plugins/galago

#%files lirc
#%defattr(-, root, root)
#%{_libdir}/totem/plugins/lirc

%files mythtv
%defattr(-, root, root)
%config %{_sysconfdir}/gnome/gconf/schemas/totem-mythtv.schemas
%{_libdir}/totem/plugins/mythtv

%files youtube
%defattr(-, root, root)
%{_libdir}/totem/plugins/youtube

%files tracker
%defattr(-, root, root)
%{_libdir}/totem/plugins/tracker

%files mozplugin
%defattr(-, root, root)
%{_libdir}/mozilla/plugins/*
%{_libdir}/totem/totem-plugin-viewer

%files publish
%defattr(-, root, root)
%{_libdir}/totem/plugins/publish

%files gstreamer
%{_libdir}/libbaconvideowidget.so.0.0.0
%{_libdir}/libbaconvideowidget-gstreamer.so.0.0.0

%if %{with_xine}
%files xine
%{_libdir}/libbaconvideowidget-xine.so.0.0.0
%endif

%changelog
* Mon Mar 24 2008 Christian Wasem <wasem@ccux-linux.de> 2.23.0-2
- rebuild, changed moz-plugin group to Internet/Plugins
* Tue Mar 18 2008 Christian Metzen <metzench@ccux-linux.de> 2.23.0-1
- Version update
* Mon Nov 05 2007 Christian Metzen <metzench@ccux-linux.de> 2.20.1-1
- Version update, switched to xine backend
* Sun Sep 30 2007 Christian Metzen <metzench@ccux-linux.de> 2.20.0-1
- Version update
* Thu Mar 22 2007 Christian Metzen <metzench@ccux-linux.de> 2.18.0-1
- Version update
* Thu Nov 16 2006 Christian Metzen <metzench@ccux-linux.de> 2.17.3-1
- Initial release